import requests
import json
import hashlib
import random
import mysql.connector
from multiprocessing import Pool

# Simulating $_POST['upi']
upi = "9369579968@ybl"

# Random name list
f = ["Vasu", "Nirmal", "Akshay", "Chander", "Rupinder", "Akhil", "Shanti", "Ravi", "Kunal", "Chandrakant",
     "Sulabha", "Mahinder", "Swapnil", "Deepa", "Sulabha", "Neelima", "Vijaya", "Nikhil", "Isha", "Siddhi",
     "Ajeet", "Kshitija", "Anila", "Jitender", "Sumeet", "Preethi", "Priti", "Gayathri", "Dhaval", "Mukesh",
     "Lalita", "Rachana", "Rakhi", "Harshal", "Shekhar", "Rajiv", "Balakrishna", "Ajeet", "Tara", "Chander",
     "Deepa", "Prabhu", "Rajendra", "Jeetendra", "Nandu", "Aniket", "Sumati", "Prabhu", "Vimal", "Indira",
     "Laxman", "Agni", "Kapil", "Kailash", "Puneet", "Pratik", "Pankaj", "Ishore", "Swati", "Rupa",
     "Hardeep", "Prabhu", "Khushi", "Gurmeet", "Nishant", "Rishi", "Naveen"]

hashkey = "*dkaSDs#*k9487ld!*kaSJDsj9784@ADS@197dsk!!dHD@dka267#SD!sk192@"

headers_common = {
    "Content-Type": "application/json",
    "Accept": "application/json",
    "campaignId": "100778999",
    "clientId": "nwHM0EqOVH6c/5J7SZ0w36EXMBoGMIlaXTeL4qN63KE=",
    "appVersion": "1.0",
    "appName": "asknestle",
    "channel": "WEB",
    "User-Agent": "Mozilla/5.0 (Linux; Android 14; RMX3870 Build/UKQ1.230924.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/132.0.6834.122 Mobile Safari/537.36"
}

# Utility Functions
def generate_indian_mobile_number():
    return str(random.choice([6, 7, 8, 9])) + str(random.randint(100000000, 999999999))

def sha256(data):
    return hashlib.sha256(data.encode()).hexdigest()

def sort_json_body(json_str):
    try:
        data = json.loads(json_str)
        sorted_data = dict(sorted(data.items(), reverse=True))
        return json.dumps(sorted_data, separators=(',', ':'))
    except Exception:
        return ""

def generate_checksum(data, hashkey):
    secret_hash = sha256(hashkey)
    sorted_body = sort_json_body(data)
    checksum_input = f"{secret_hash}{sorted_body}" if sorted_body not in ["", "{}"] else secret_hash
    return sha256(checksum_input)

# Task to simulate user interaction and DB insertion
def execute_task(_):
    try:
        fname = random.choice(f)
        email = f"{fname}{random.randint(1000, 9000)}@gmail.com"
        num = generate_indian_mobile_number()

        # Step 1
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/save-user-detail"
        data = json.dumps({
            "msisdn": num,
            "firstName": fname,
            "lastName": "",
            "emailId": email,
            "howOldIsYourKid": "Between 2-6 Years Old",
            "state": "Delhi",
            "consent1": True,
            "consent2": True,
            "isLoginAllowed": False,
            "ssoId": "NA"
        })
        checksum = generate_checksum(data, hashkey)
        headers = headers_common.copy()
        headers.update({"checksum": checksum, "msisdn": num})
        response = requests.post(url, data=data, headers=headers)
        if response.status_code != 200:
            print(f"Step 1 error: {response.status_code}")
            return

        # Step 2
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/save-answers"
        data = json.dumps({
            "msisdn": num,
            "answersMap": {
                "trivia1": {"answer": "Carbohydrate", "question": "Which nutrient is the major source of energy for the body?", "isCorrect": True},
                "trivia2": {"answer": "It has nutrients for good gut health", "question": "This is a benefit of eating curd?", "isCorrect": True},
                "trivia3": {"answer": "2000 kcal", "question": "What is the average energy requirement for an adult per day?", "isCorrect": True},
                "trivia4": {"answer": "Milk & milk products", "question": "Fiber rich food does not include?", "isCorrect": True},
                "trivia5": {"answer": "Guava", "question": "Which among these is NOT a good source of vitamin A?", "isCorrect": True}
            }
        })
        checksum = generate_checksum(data, hashkey)
        headers.update({"checksum": checksum})
        response = requests.post(url, data=data, headers=headers)
        if response.status_code != 200:
            print(f"Step 2 error: {response.status_code}")
            return

        # Step 3
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/save-upi-info"
        data = json.dumps({"vpa": upi})
        checksum = generate_checksum(data, hashkey)
        headers.update({"checksum": checksum})
        response = requests.post(url, data=data, headers=headers)
        result = response.json()
        print(result)

        if result.get("status") == "SUCCESS":
            try:
                conn = mysql.connector.connect(
                    host="localhost",
                    user="freefok2_nestle",
                    password="Niraj1209!",
                    database="freefok2_nestle"
                )
                cursor = conn.cursor()
                cursor.execute("INSERT INTO nestle (number) VALUES (%s)", (num,))
                conn.commit()
                print(f"Inserted {num} into database.")
                cursor.close()
                conn.close()
            except mysql.connector.Error as err:
                print(f"DB Error: {err}")
        else:
            print("UPI Step not successful.")
    except Exception as e:
        print(f"Exception in task: {e}")

# Task to run redemption for existing numbers
def redemption_task(num):
    try:
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/redemption"
        data = json.dumps({"redemptionType": "CASHBACK"})
        checksum = generate_checksum(data, hashkey)

        headers = headers_common.copy()
        headers.update({"checksum": checksum, "msisdn": str(num)})

        response = requests.post(url, data=data, headers=headers)
        print(f"Redemption response for {num}: {response.json()}")
    except Exception as e:
        print(f"Redemption failed for {num}: {e}")

# Pull numbers from DB and run redemption using pool
def run_redemption_for_existing_numbers():
    try:
        conn = mysql.connector.connect(
            host="136.243.92.92",
            user="freefok2_nestle",
            password="Niraj1209!",
            database="freefok2_nestle"
        )
        cursor = conn.cursor()
        cursor.execute("SELECT number FROM nestle")
        numbers = [num[0] for num in cursor.fetchall()]
        cursor.close()
        conn.close()

        # Run redemption in parallel
        with Pool(70) as pool:
            pool.map(redemption_task, numbers)

    except mysql.connector.Error as err:
        print(f"Database error: {err}")

# Main execution
if __name__ == '__main__':
    # Run initial data creation if needed
    # with Pool(100) as pool:
    #     pool.map(execute_task, range(100))

    # Run redemption for all DB entries in parallel
    run_redemption_for_existing_numbers()